#include "HelloWorldScene.h"

#include "ui/CocosGUI.h"

USING_NS_CC;

using namespace cocos2d::ui;

Scene* HelloWorld::createScene()
{
    // 'scene' is an autorelease object
    auto scene = Scene::create();
    
    // 'layer' is an autorelease object
    auto layer = HelloWorld::create();

    // add layer as a child to scene
    scene->addChild(layer);

    // return the scene
    return scene;
}

// on "init" you need to initialize your instance
bool HelloWorld::init()
{
    //////////////////////////////
    // 1. super init first
    if ( !Layer::init() )
    {
        return false;
    }
    
    Size visibleSize = Director::getInstance()->getVisibleSize();
    Vec2 origin = Director::getInstance()->getVisibleOrigin();

	/// init background
	auto _bg = Sprite::create("spr_background_mainmenu.png");
	_bg->setPosition(visibleSize / 2);
	addChild(_bg);

	/// init popup setting components
	m_popupSetting = PopupSetting::create();
	m_popupSetting->retain();

	addChild(m_popupSetting);

	/// init button setting when click -> appear popup setting component
	auto _btnSetting = Button::create("spr_button_short_disable.png", "spr_button_short_normal.png", "spr_button_short_selected.png");
	_btnSetting->setPosition(Vec2(visibleSize.width * 1 / 10 + origin.x, visibleSize.height * 2 / 10 + origin.y));
	_btnSetting->setTitleText("Setting");
	_btnSetting->setTitleFontSize(50);

	_btnSetting->addTouchEventListener([&](Ref* sender, Widget::TouchEventType type)
	{
		switch (type)
		{
		case ui::Widget::TouchEventType::BEGAN:
			break;
		case ui::Widget::TouchEventType::ENDED:
			m_popupSetting->appear();
			break;
		default:
			break;
		}
	});
	this->addChild(_btnSetting);
	/*------------------------------------------------------------------*/
	
	
	
	/// init button back when click -> disappear popup setting component
	auto _btnBack = Button::create("spr_button_short_disable.png", "spr_button_short_normal.png", "spr_button_short_selected.png");
	_btnBack->setPosition(Vec2(visibleSize.width * 1 / 10 + origin.x, visibleSize.height * 4 / 10 + origin.y));
	_btnBack->setTitleText("Back");
	_btnBack->setTitleFontSize(50);

	_btnBack->addTouchEventListener([&](Ref* sender, Widget::TouchEventType type)
	{
		switch (type)
		{
		case ui::Widget::TouchEventType::BEGAN:
			break;
		case ui::Widget::TouchEventType::ENDED:
			m_popupSetting->disappear();
			break;
		default:
			break;
		}
	});
	this->addChild(_btnBack);
	/*------------------------------------------------------------------*/
    
    return true;
}


void HelloWorld::menuCloseCallback(Ref* pSender)
{
    Director::getInstance()->end();

#if (CC_TARGET_PLATFORM == CC_PLATFORM_IOS)
    exit(0);
#endif
}
