///@ Popup.cpp
#include "Popup.h"

bool Popup::init() {
	if (!Node::init()) {
		return false;
	}

	
	visibleSize = Director::getInstance()->getVisibleSize();
	origin = Director::getInstance()->getVisibleOrigin();

	/// init image background
	auto _background = Sprite::create("spr_background_popup.png");
	_background->setAnchorPoint(Vec2::ZERO);
	_background->setPosition(Vec2::ZERO);

	backgroundContentSize = _background->getContentSize();

	m_popupLayer = Layer::create();
	m_popupLayer->setAnchorPoint(Vec2::ZERO);
	m_popupLayer->setPosition(Vec2(visibleSize.width + origin.x, origin.y));
	this->addChild(m_popupLayer, 99);

	m_popupLayer->addChild(_background);
	/*------------------------------------------------------------------*/


	/// init two acction for poup
	m_appearAction = TargetedAction::create(m_popupLayer,
		MoveTo::create(0.5f, Vec2(visibleSize.width - _background->getContentSize().width + origin.x, origin.y)));
	
	m_disappearAction = TargetedAction::create(m_popupLayer,
		MoveTo::create(0.5f, Vec2(visibleSize.width + origin.x, origin.y)));
	/*------------------------------------------------------------------*/


	m_appearAction->retain();
	m_disappearAction->retain();
	
	return true;
}

void Popup::onExit() {
	m_appearAction->release();
	m_disappearAction->release();

	Node::onExit();
}

void Popup::disappear() {
	this->runAction(m_disappearAction->clone());
}

void Popup::appear() {	
	this->runAction(m_appearAction->clone());
}


void Popup::setTitlePopup(std::string _titlePopup) {
	auto _title = Label::create(_titlePopup, "arial.ttf", 200);
	_title->setPosition(Point(backgroundContentSize.width / 2 + origin.x, backgroundContentSize.height * 8 / 10 + origin.y));
	
	m_popupLayer->addChild(_title);
}